#include <SoftwareSerial.h>
#include <ESP8266WiFi.h>
#include <espnow.h>

uint8_t broadcastAddress[] = { 0x68, 0xB6, 0xB3, 0x37, 0xF2, 0x74 };


unsigned long lastTime = 0;
unsigned long timerDelay = 2000;  // send readings timer

SoftwareSerial mySerial(D5, D6);  // RX, TX

typedef struct struct_message {
  int id;  // must be unique for each sender board
  int dust;
  int LPG;
  int Co;
  int Smoke;
} struct_message;

struct_message myData;

void OnDataSent(uint8_t *mac_addr, uint8_t sendStatus) {
  Serial.print("Last Packet Send Status: ");
  if (sendStatus == 0) {
    Serial.println("Delivery success");
  } else {
    Serial.println("Delivery fail");
  }
}

void stoi(String temp) {
  int i = 0;
  while (temp.length()-1!=i) {
    char dust[100];
    char co[100];
    char lpg[100];
    char smoke[100];
    if (temp[i] == 'D') {
      int j = 0;
      i++;
      while (!(temp[i] > 'A' && temp[i] < 'Z')) {
        dust[j] = temp[i];
        j++;
        i++;
        // Serial.println(i);
        // Serial.println(j);
      }
      String x = (String)dust;
      myData.dust = x.toInt();

      // Serial.println(x);
    }
    if (temp[i] == 'L') {
      int j = 0;
      i++;
      while (!(temp[i] > 'A' && temp[i] < 'Z')) {
        lpg[j] = temp[i];
        j++;
        i++;
      }
      String x = (String)lpg;
      myData.LPG = x.toInt();
    }
    if (temp[i] == 'C') {
       int j = 0;
       i++;
       while (!(temp[i] > 'A' && temp[i] < 'Z')) {
         co[j] = temp[i];
         j++;
         i++;
       }
       String x = (String)co;
       myData.Co = x.toInt();
      }
      if (temp[i] == 'S') {
        int j = 0;
        i++;
        while (!(temp[i] > 'A' && temp[i] < 'Z')&&temp.length()-1!=i) {
          smoke[j] = temp[i];
          j++;
          i++;
        }
        String x = (String)smoke;
        myData.Smoke = x.toInt();
      }
    if (temp.length()-1>=i) 
    {
      Serial.println("End Stoi");
      break;
    }
    
  }
}

void setup() {
  // Open serial communications and wait for port to open:
  Serial.begin(9600);
  while (!Serial) {
    ;  // wait for serial port to connect. Needed for native USB port only
  }


  //Serial.println("Goodnight!");

  // set the data rate for the SoftwareSerial port
  mySerial.begin(9600);
 // mySerial.println("Hello?");
 WiFi.mode(WIFI_STA);

  // Init ESP-NOW
  if (esp_now_init() != 0) {
    Serial.println("Error initializing ESP-NOW");
    return;
  }

  // Once ESPNow is successfully Init, we will register for Send CB to
  // get the status of Trasnmitted packet
  esp_now_set_self_role(ESP_NOW_ROLE_CONTROLLER);
  esp_now_register_send_cb(OnDataSent);

  // Register peer
  esp_now_add_peer(broadcastAddress, ESP_NOW_ROLE_SLAVE, 1, NULL, 0);
}

void loop() {  // run over and over
  if (mySerial.available()) {
    char data[100] = " ";
    char temp = mySerial.read();
    int i = 0;
    while (temp != (char)'*') {
      data[i] = temp;
      i++;
      while (!mySerial.available()) delay(1);
      temp = mySerial.read();
      if (temp == '*') break;
    }
    data[i] = '\0';
    String Data1 = String(data)+"X";
    Serial.println(Data1);
    stoi(Data1);
    Serial.println(myData.dust);
    Serial.println(myData.LPG);
    Serial.println(myData.Co);
    Serial.println(myData.Smoke);
    myData.id=1;
    esp_now_send(broadcastAddress, (uint8_t *)&myData, sizeof(myData));
  }
  delay(1);
}