#include <WiFi.h>
#include <PubSubClient.h>
#include "config.h"
#include <HardwareSerial.h>

WiFiClient wifiClient;
PubSubClient mqtt(MQTT_BROKER, 1883, wifiClient);
uint32_t last_publish;
uint32_t last_publish_sw;

bool board1 = false, board2 = false, board3 = false;

HardwareSerial SerialPort(1);  // use UART2

String payload1;
String payload2;
String payload3;
String payload4;
String payload5;
String payload6;
String payload7;
String payload8;
String payload9;
String payload10;

String stoi(String x, String y) {
  int f_index = x.indexOf(y);
  if (f_index == -1) return "-1";
  int s_index = x.indexOf(',', f_index);
  String ans = x.substring(f_index + 1, s_index);
  // Serial.print("x : ");
  // Serial.println(x);
  // Serial.print("y : ");
  // Serial.println(y);
  // Serial.print("ans : ");
  // Serial.println(ans);
  return ans;
}

void connect_wifi() {
  printf("WiFi MAC address is %s\n", WiFi.macAddress().c_str());
  printf("Connecting to WiFi %s.\n", WIFI_SSID);
  WiFi.mode(WIFI_STA);
  WiFi.begin(WIFI_SSID, WIFI_PASS);
  while (WiFi.status() != WL_CONNECTED) {
    printf(".");
    fflush(stdout);
    delay(500);
  }
  printf("\nWiFi connected.\n");
}


void connect_mqtt() {
  printf("Connecting to MQTT broker at %s.\n", MQTT_BROKER);
  if (!mqtt.connect(MQTT_BROKER, MQTT_USER, MQTT_PASS)) {
    printf("Failed to connect to MQTT broker.\n");
    printf("%d\n", mqtt.state());
    for (;;) {}  // wait here forever
  }
  mqtt.setCallback(mqtt_callback);
  mqtt.subscribe("#");
  printf("MQTT broker connected.\n");
}


void mqtt_callback(char* topic, byte* payload, unsigned int length) {
  Serial.println(topic);
  if (strcmp(topic, "light/0") == 0) {
    payload[length] = 0;  // null-terminate the payload to treat it as a string
    int value = atoi((char*)payload);
    // code here
    String data = "light1 " + (String)(value) + (String)'*';
    SerialPort.println(data);
    // Serial.println(data);
    // Serial.println(value);
    // Serial.println((char)(value + '0'));
  }
  if (strcmp(topic, "light/1") == 0) {
    payload[length] = 0;  // null-terminate the payload to treat it as a string
    int value = atoi((char*)payload);
    // code here
    String data = "light2 " + (String)(value) + (String)'*';
    SerialPort.println(data);
  }
  if (strcmp(topic, "light/2") == 0) {
    payload[length] = 0;  // null-terminate the payload to treat it as a string
    int value = atoi((char*)payload);
    // code here
    String data = "light3 " + (String)(value) + (String)'*';
    SerialPort.println(data);
  }
  if (strcmp(topic, "light/3") == 0) {
    payload[length] = 0;  // null-terminate the payload to treat it as a string
    int value = atoi((char*)payload);
    // code here
    String data = "light4 " + (String)(value) + (String)'*';
    SerialPort.println(data);
  }
  if (strcmp(topic, "light/4") == 0) {
    payload[length] = 0;  // null-terminate the payload to treat it as a string
    int value = atoi((char*)payload);
    // code here
    String data = "light5 " + (String)(value) + (String)'*';
    SerialPort.println(data);
  }
  if (strcmp(topic, "light/5") == 0) {
    payload[length] = 0;  // null-terminate the payload to treat it as a string
    int value = atoi((char*)payload);
    // code here
    String data = "light6 " + (String)(value) + (String)'*';
    SerialPort.println(data);
  }
  if (strcmp(topic, "light/6") == 0) {
    payload[length] = 0;  // null-terminate the payload to treat it as a string
    int value = atoi((char*)payload);
    // code here
    String data = "light7 " + (String)(value) + (String)'*';
    SerialPort.println(data);
  }
  if (strcmp(topic, "light/7") == 0) {
    payload[length] = 0;  // null-terminate the payload to treat it as a string
    int value = atoi((char*)payload);
    // code here
    String data = "light8 " + (String)(value) + (String)'*';
    SerialPort.println(data);
  }
  if (strcmp(topic, "ac/power") == 0) {
    payload[length] = 0;  // null-terminate the payload to treat it as a string
    int value = atoi((char*)payload);
    // code here
    String data = "ac " + (String)(value) + (String)'*';
    SerialPort.println(data);
  }
  if (strcmp(topic, "ac/temp") == 0) {
    payload[length] = 0;  // null-terminate the payload to treat it as a string
    int value = atoi((char*)payload);
    // code here 
    String data = "temp" + (String)(value) + (String)'*';
    SerialPort.println(data);
  }  
  if (strcmp(topic, "ac/fan") == 0) {
    payload[length] = 0;  // null-terminate the payload to treat it as a string
    int value = atoi((char*)payload);
    // code here
    String data = "acfan " + (String)(value) + (String)'*';

    SerialPort.println(data);
  }
}


void setup() {
  Serial.begin(115200);
  connect_wifi();
  connect_mqtt();
  SerialPort.begin(9600, SERIAL_8N1, 18, 17);
}


void loop() {

  // check for incoming subscribed topics
  mqtt.loop();
  if (SerialPort.available()) {
    char data[100] = "";
    char temp = SerialPort.read();
    int i = 0;
    while (temp != (char)'*') {
      data[i] = temp;
      i++;
      while (!SerialPort.available()) delay(1);
      temp = SerialPort.read();
      if (temp == '*') break;
    }
    data[i] = '\0'; 
    String Data1 = String(data);
    if (Data1.indexOf("D") != -1) {
      board1 = true;
      payload1 = stoi(Data1, "D");
      payload10 = stoi(Data1, "L");
      payload7 = stoi(Data1, "C");
      payload8 = stoi(Data1, "S");
    } else if (Data1.indexOf("W") != -1) {
      board2 = true;
      payload9 = stoi(Data1, "W");
      // Serial.print("Watt data : ");
      // Serial.println(Data1);
    } else if (Data1.indexOf("T") != -1) {
      board3 = true;
      payload2 = stoi(Data1, "U");
      payload3 = stoi(Data1, "H");
      payload4 = stoi(Data1, "V");
      payload5 = stoi(Data1, "I");
      payload6 = stoi(Data1, "T");
      //Serial.print("Temperature data : ");
      //Serial.println(Data1);
      // }
      // Serial.print("Data[0] : ");
      // Serial.println(data[0]);
      // Serial.println(Data1);
      // Serial.print("board1: ");
      // Serial.print(board1);
      // Serial.print(" board2: ");
      // Serial.print(board2);
      // Serial.print(" board3: ");
      // Serial.println(board3);
    }
    // publish light value periodically (without using delay)
    if(payload10.toInt() > 1000){
      mqtt.publish("lpg", payload10.c_str());
    }
    //Serial.print("Temperature data : ");
    //Serial.println(payload10);
    uint32_t now = millis();
    if (now - last_publish >= 60000 && board1 && board2 && board3) {

      // Serial.println("-----------Payload-------------");
      // Serial.print("payload1 : ");
      // Serial.println(payload1);
      // Serial.print("payload2 : ");
      // Serial.println(payload2);
      // Serial.print("payload3 : ");
      // Serial.println(payload3);
      // Serial.print("payload4 : ");
      // Serial.println(payload4);
      // Serial.print("payload5 : ");
      // Serial.println(payload5);
      // Serial.print("payload6 : ");
      // Serial.println(payload6);
      // Serial.print("payload7 : ");
      // Serial.println(payload7);
      // Serial.print("payload8 : ");
      // Serial.println(payload8);
      // Serial.print("payload9 : ");
      // Serial.println(payload9);
      // Serial.print("payload10 : ");
      // Serial.println(payload10);
      // Serial.println("-------------------------------");

      // Publishing . . .
      mqtt.publish("app/dust", payload1.c_str());
      mqtt.publish("app/uv", payload2.c_str());
      mqtt.publish("app/humidity", payload3.c_str());
      mqtt.publish("app/vis", payload4.c_str());
      mqtt.publish("app/ir", payload5.c_str());
      mqtt.publish("app/temp", payload6.c_str());
      mqtt.publish("co", payload7.c_str());
      mqtt.publish("app/smoke", payload8.c_str());      
      mqtt.publish("app/watt", payload9.c_str());
      // end - -

      board1 = false;
      board2 = false;
      board3 = false;
      last_publish = now;
    }
  }
}
